// InpoutTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#define DATA 1
#define LOAD 2
#define CLK 0

/* ----Prototypes of Inp and Outp--- */

short _stdcall Inp32(short PortAddress);
void _stdcall Out32(short PortAddress, short data);
unsigned char b;
/*--------------------------------*/
//2 = DIN
//4 = load
//1 = clk

void delay(int d)
{
	for(int h=0;h<300;h++)
		for(int i=0;i<100*d;i++)
		{
			;
		}
}
void output_high(char bit)
{
	char temp = 1 << bit;
	b |= temp;
	Out32(0x378,b);
	delay(10);
}
void output_low(char bit)
{
	char temp = 1 << bit;
	b &= ~temp;
	Out32(0x378,b);
	delay(10);
}
int bit_test(char var,char bit)
{
	return ((var & (1<<bit)) == 1<<bit);
}




void max7219(char adress,char value)
{
 char x;
// Before the data will transfer, first the pin LOAD is set on LOW.
// The data begin with the bit D15, thus MSB
 output_low(LOAD);
// The data bits D15-D12 are transferred
// Since these are not important, 0 one conveys
 for (x=0;x<4;x++)
 {
  output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }
// The data bits D11-D8 contain the register address of the MAX7219
 for (x=4;x>0;x--)
 {
  if (bit_test(adress,x-1)) output_high(DATA);
  else output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }
// The data bits D7-D0 are the data to the MAX7219
 for (x=8;x>0;x--)
 {
  if (bit_test(value,x-1)) output_high(DATA);
  else output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }
// In the end the pin LOAD is set on HIGH, thus is those
// Data communication to end
 output_high(LOAD);
}

void max7219_init()
{
 max7219(0x0b, 0x07); // Here the number of digits is indicated (7digits)
 max7219(0x0c, 0x01); // Displays are set on normal operation (noshutdown)
 max7219(0x09,0x00); // Displays are set on normal operation (nodisplay test)
 max7219(0x0a, 0x0F); // The brightness of the digits is stopped here
}


int main()
{
	b=0;

	output_high(LOAD); // The pin LOAD at the MAX7219 is set as the first on HIGH
   output_low(CLK); // The pin CLK at the MAX7219 is set as the first on HIGH
   max7219_init(); // The routine initialize the MAX7219
   unsigned char digit=1; // Variable digit goes through all digits and on first is set
   unsigned char data=1; // Variable data are the data of 0-9 for the individual digits
   while (1)
     {
       max7219(digit,data); // That is the output routine for the MAX7219
       delay(50);
	   printf("%d - %d\n",digit,data);
       data <<= 1;
       if(data == 0){ data = 1; digit++; }
       if(digit == 8){ digit = 1;}

     }


	


	return 0;
}
